global.chatSendBuffer = buffer_create();
global.chatReceiveBuffer = buffer_create();
global.chatPacketID = argument1;
global.chatLog = ds_list_create();
ds_list_add(global.chatLog,"Lorgan3's chat plugin v1 - press T to show/hide,");
ds_list_add(global.chatLog,"Y to chat");
global.consoleFont = font_add("Lucida Console",8,0,0,32,127);
global.chatSprite = sprite_add(argument0+"/ConsoleWindowS.png",2,0,0,0,0);

//create the new object
object_event_add(PlayerControl,ev_step,ev_step_begin,'
    if !instance_exists(global.chatWindow) instance_create(0,0,global.chatWindow)
');

//add the new object and set persistent
global.chatWindow = object_add();
object_set_persistent(global.chatWindow,true);

//initialize
object_event_add(global.chatWindow,ev_create,0,'
    sprite_index = global.chatSprite;
    open=false;
    hidden=true;
    offset = 0;
    text1 = "";
    text2 = "";
    image_speed=0;
    
    idle = false;
');
object_event_add(global.chatWindow,ev_alarm,0,"
    idle = true;
");

//send and receive messages and some other stuff
object_event_add(global.chatWindow,ev_step,ev_step_end,"
    x = view_xview[0]+7;
    y = view_yview[0]+340;
    if keyboard_check_pressed(ord('T')) {
        if !open hidden = !hidden;
        idle = false;
        alarm[0]=120;
    } else if !open {
        if keyboard_check_pressed(ord('Y')) {
            open = true;
            hidden = false;
            keyboard_string='';
            instance_create(0,0,global.cheatycheat);
        }
    } else if open && keyboard_check_pressed(vk_enter) {
        with(global.cheatycheat) instance_destroy();
        if keyboard_string != '' {
            keyboard_string = global.myself.name+': '+keyboard_string;
            write_ubyte(global.chatSendBuffer,min(255,string_length(keyboard_string)));
            write_string(global.chatSendBuffer,string_copy(keyboard_string,0,255));
            PluginPacketSend(global.chatPacketID,global.chatSendBuffer);
            buffer_clear(global.chatSendBuffer);
            if global.isHost {
                if string_length(keyboard_string) > 52 {
                    ds_list_add(global.chatLog,string_copy(keyboard_string,0,52));
                    ds_list_add(global.chatLog,string_copy(keyboard_string,52,255));
                } else ds_list_add(global.chatLog,keyboard_string);
            }
            keyboard_string='';
        }
        open = false;
        offset = 0;
        idle = false;
        alarm[0]=120;
    }
    
    if open {        
        image_index = 1;
        if (keyboard_check_pressed(vk_up) or mouse_wheel_up()) && ds_list_size(global.chatLog) > 9 offset = min(ds_list_size(global.chatLog)-10,offset+1);
        else if keyboard_check_pressed(vk_down) or mouse_wheel_down() offset = max(0,offset-1);
    } else image_index = 0;
    
    //check for messages
    while(PluginPacketGetBuffer(global.chatPacketID) != -1) {
        global.chatReceiveBuffer = PluginPacketGetBuffer(global.chatPacketID)
        _len = read_ubyte(global.chatReceiveBuffer);
        _message = read_string(global.chatReceiveBuffer,_len);
        if string_length(keyboard_string) > 52 {
            ds_list_add(global.chatLog,string_copy(_message,0,52));
            ds_list_add(global.chatLog,string_copy(_message,52,255));
        } else ds_list_add(global.chatLog,_message);
        
        //make the window display the new message
        alarm[0]=120;
        idle = false
        
        buffer_clear(global.chatReceiveBuffer);
        PluginPacketPop(global.chatPacketID);
        
        //forward the packet to all players
        if global.isHost {
            write_ubyte(global.chatSendBuffer,min(255,string_length(_message)));
            write_string(global.chatSendBuffer,string_copy(_message,0,255));
            PluginPacketSend(global.chatPacketID,global.chatSendBuffer);
            buffer_clear(global.chatSendBuffer);
        }
    }
");

//draw
object_event_add(global.chatWindow,ev_draw,0,'
    var xoffset, yoffset, xsize, ysize, index;
    
    xsize = sprite_width;
    ysize = sprite_height;
    
    draw_set_valign(fa_top);
    draw_set_halign(fa_left);
    draw_set_color(c_white);
    draw_set_alpha(1);
    draw_set_font(global.consoleFont);
    
    if !hidden {
        draw_sprite_ext(sprite_index,image_index,x,y,1,1,0,c_white,0.7);
    }
    
    //prevent too long strings
    if open {
        //limit messages, 90 characters should be enough
        keyboard_string = string_copy(keyboard_string,1,90);
        
        //make that the text doesnt go outside the chatwindow
        if string_length(keyboard_string)-53 > 0 index  = string_length(keyboard_string)-52;
        else index = 0;
        chatmessage = string_copy(keyboard_string,index,53);
        
        draw_text(x + 3, y+ysize-15, chatmessage);
    }
    
    // The drawing of the text
    var message, amount;
    if !hidden amount = min(ds_list_size(global.chatLog),10);
    else if !idle amount = min(ds_list_size(global.chatLog),2);
    else amount = 0;
    for(i=0;i<amount;i+=1) {
        message = ds_list_find_value(global.chatLog, ds_list_size(global.chatLog)-amount+i-offset);
        draw_text(x+10, y+ysize-40-12*(amount-i),message);
    }
    
    draw_set_font(global.gg2Font);
');

//create a cheaty cheat object to prevent you from moving and opening chat menus while typing :p
global.cheatycheat = object_add();
object_set_parent(global.cheatycheat,InGameMenuController);
object_event_add(global.cheatycheat,ev_step,ev_step_normal,'//no');
object_event_add(global.cheatycheat,ev_draw,0,'//no');
object_event_add(global.cheatycheat,ev_keypress,vk_enter,'//no');
object_event_add(global.cheatycheat,ev_keypress,vk_escape,'
    with(global.chatWindow) open = false;
    instance_create(0,0,InGameMenuController);
    instance_destroy();
');